#ifndef SUDOKU_H
#define SUDOKU_H

/*
 * G_R_Y_X_V_CODED fields:
 *   G - grade, the higher the more difficult to find
 *   R - reason, explanation why this solution is found
 *   Y - row of the cel counted beginning at top with zero
 *   X - column of the cel counted from the left beginning at zero
 *   V - value to put in the cel
 */
#define G_R_Y_X_V_CODED(g,r,y,x,v)	(((g)<<23)|((r)<<18)|((y)<<13)|((x)<<8)|(v))
#define V_DECODED(z)	((z)&0xff)
#define X_DECODED(z)	(((z)>>8)&0x1f)
#define Y_DECODED(z)	(((z)>>13)&0x1f)
#define R_DECODED(z)	(((z)>>18)&0x1f)
#define G_DECODED(z)	(((z)>>23)&0x1f)

void init_sudoku(int rib, const char *cels);
int getcel(int i, int j);
int morethanonecandidates(int i, int j, char *candidates);
int unsolved(void);
int travelsudoku(void);	/* returns G_R_Y_X_V_CODED(g,r,y,x,v) or zero */
const char *explanation(int hint);
int picknumber(int high);	/* pick a number between 0 and high */
void generatesolved(int (*cb)(void));
char *sudokulines(void);	/* one long string with rows seperated by newline */

extern int sudokuvalid;

#endif
